/**
 * \file
 *
 * \brief megaAVR޲n`
 *
 * 쌠 (C) 2011 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef MEGA_PARTS_H
#define MEGA_PARTS_H

//! GCCIAR޲`ɕ֗ϸ
#define part_is_defined(part) \
	(defined(__ ## part ## __) || defined(__AVR_ ## part ## __))

// ATmegaxx0
#define MEGA_XX0 (\
		part_is_defined(ATmega640) || \
		part_is_defined(ATmega1280) || \
		part_is_defined(ATmega2560) \
	)

// ATmegxx1
#define MEGA_XX1 (\
		part_is_defined(ATmega1281) || \
		part_is_defined(ATmega2561) \
	)

// ATmegaxx0/xx1
#define MEGA_XX0_1	(MEGA_XX0 || MEGA_XX1)

// ATmegaxx4
#define MEGA_XX4 (\
		part_is_defined(ATmega164A) || part_is_defined(ATmega164PA) || \
		part_is_defined(ATmega324) || part_is_defined(ATmega324A) || \
		part_is_defined(ATmega324PA) || part_is_defined(ATmega644) || \
		part_is_defined(ATmega644A) || part_is_defined(ATmega644PA) || \
		part_is_defined(ATmega1284P) \
	)

// ATmegaxx4
#define MEGA_XX4_A (\
		part_is_defined(ATmega164A) || part_is_defined(ATmega164PA) || \
		part_is_defined(ATmega324A) || part_is_defined(ATmega324PA) || \
		part_is_defined(ATmega644A) || part_is_defined(ATmega644PA) || \
		part_is_defined(ATmega1284P) \
	)

// ATmegaxx8
#define MEGA_XX8 (\
		part_is_defined(ATmega48) || part_is_defined(ATmega48A) || \
		part_is_defined(ATmega48PA) || part_is_defined(ATmega88) || \
		part_is_defined(ATmega88A) || part_is_defined(ATmega88PA) || \
		part_is_defined(ATmega168) || part_is_defined(ATmega168A) || \
		part_is_defined(ATmega168PA) || part_is_defined(ATmega328) || \
		part_is_defined(ATmega328P) \
	)

// ATmegaxx8A/P/PA
#define MEGA_XX8_A (\
		part_is_defined(ATmega48A) || part_is_defined(ATmega48PA) || \
		part_is_defined(ATmega88A) || part_is_defined(ATmega88PA) || \
		part_is_defined(ATmega168A) || part_is_defined(ATmega168PA) || \
		part_is_defined(ATmega328P) \
	)

// ATmegaxx
#define MEGA_XX (\
		part_is_defined(ATmega16) || part_is_defined(ATmega16A) || \
		part_is_defined(ATmega32) || part_is_defined(ATmega32A) || \
		part_is_defined(ATmega64) || part_is_defined(ATmega64A) || \
		part_is_defined(ATmega128) || part_is_defined(ATmega128A) \
	)

// ATmegaxxA/P/PA
#define MEGA_XX_A (\
		part_is_defined(ATmega16A) || part_is_defined(ATmega32A) || \
		part_is_defined(ATmega64A) || part_is_defined(ATmega128A) \
	)

// w
#define MEGA_UNSPECIFIED (\
		part_is_defined(ATmega16) || part_is_defined(ATmega16A) || \
		part_is_defined(ATmega32) || part_is_defined(ATmega32A) || \
		part_is_defined(ATmega64) || part_is_defined(ATmega64A) || \
		part_is_defined(ATmega128) || part_is_defined(ATmega128A) || \
		part_is_defined(ATmega169P) || part_is_defined(ATmega169PA) || \
		part_is_defined(ATmega329P) || part_is_defined(ATmega329PA) \
	)

// SmegaAVR޲
#define MEGA (MEGA_XX0_1 || MEGA_XX4 || MEGA_XX8 || MEGA_XX || MEGA_UNSPECIFIED)

#endif /* MEGA_PARTS_H */
